import java.util.ArrayList;


public class OrthogonalSignMatrix {
	Sign[] m = new Sign[19];// rotation matrix
	static int n=0;
	ArrayList<Sign[]> valueMatricesList;
	OrthogonalSignMatrix(Sign x1, Sign y1, Sign z1, Sign x2,Sign y2){
		m[0] = x1;
		m[1] = y1;
		m[2] = z1;	
		m[3] = x2;
		m[4] = y2;
		Sign z2  = new Sign(Sign.Ind);
		if(!z1.equals(Sign.Zer)) z2 = Sign.dot2(Sign.negation(Sign.sum2( Sign.dot2(x1,x2), Sign.dot2(y1, y2) )), z1);// if z1 is not zero may be we can deremined sign of z2
		m[9]=z2;
		m[10] = Sign.sum2(Sign.dot2(m[1], m[9]),Sign.negation(Sign.dot2(m[2], m[4])));
		m[11] = Sign.sum2(Sign.dot2(m[2], m[3]),Sign.negation(Sign.dot2(m[0], m[9])));
		m[12] = Sign.sum2(Sign.dot2(m[0], m[4]),Sign.negation(Sign.dot2(m[1], m[3])));
		valueMatricesList = new ArrayList<Sign[]>();
		valueMatricesList.add(m.clone());
		if(!z2.equals(Sign.Ind)) 
			fillZ2(z2);
		else for(int i=-1;i<2; i++){
			fillZ2(new Sign(i));
			m[14+i] = Sign.sum2(Sign.dot2(m[1], new Sign(i)),Sign.negation(Sign.dot2(m[2], m[4])));//m[13],14 and 15 stores sign of x3 after evaluating z2
			m[17+i] = Sign.sum2(Sign.dot2(m[2], m[3]),Sign.negation(Sign.dot2(m[0], new Sign(i))));//m[16],17 and 18 stores sign of y3 after evaluating z2
		}
		SignRotationMatrix.matrixMap.put(rowRep(), valueMatricesList);
	}
	
	private void fillZ2(Sign z2){
		m[5] = z2;	
		Sign x3 = Sign.sum2(Sign.dot2(m[1], m[5]),Sign.negation(Sign.dot2(m[2], m[4])));
		if(!x3.equals(Sign.Ind)) 
			fillX3(x3);
		else for(int i=-1;i<2; i++) {
			fillX3(new Sign(i));
		}
	}
	private void fillX3(Sign x3){	
		m[6]=x3;
		Sign y3=Sign.sum2(Sign.dot2(m[2], m[3]),Sign.negation(Sign.dot2(m[0], m[5])));
		if(!y3.equals(Sign.Ind)) 
			fillY3(y3);
		else for(int i=-1;i<2; i++) {
			fillY3(new Sign(i));
		}
	}
	private void fillY3(Sign y3){
		m[7] = y3;
	    Sign z3 = Sign.sum2(Sign.dot2(m[0], m[4]),Sign.negation(Sign.dot2(m[1], m[3])));
	    if(!z3.equals(Sign.Ind)) 
			fillZ3(z3);
		else for(int i=-1;i<2; i++) {
			fillZ3(new Sign(i));
		}
	}
	private void fillZ3(Sign z3){
		m[8] = z3;
		if(!Sign.sum3(m[0], m[1], m[2]).equals(Sign.Zer) && // TO avoid rows entirely zeros
		   !Sign.sum3(m[3], m[4], m[5]).equals(Sign.Zer) &&
		   !Sign.sum3(m[6], m[7], m[8]).equals(Sign.Zer) &&
		   
		   Sign.noSigned(Sign.sum3(Sign.dot2(m[0],m[3]), Sign.dot2(m[1],m[4]), Sign.dot2(m[2],m[5]))) && // To avoid dot product deterministically + or -
		   Sign.noSigned(Sign.sum3(Sign.dot2(m[3],m[6]), Sign.dot2(m[4],m[7]), Sign.dot2(m[5],m[8]))) && 
		   Sign.noSigned(Sign.sum3(Sign.dot2(m[0],m[6]), Sign.dot2(m[1],m[7]), Sign.dot2(m[2],m[8])))){ 
				n++;
				SignRotationMatrix.signMatList.add(m.clone());
				//System.out.println(printMatrix());
		}		
	}
	public boolean equals(OrthogonalSignMatrix that){
		String ths="";
		String tht="";
		for(int i=0; i<9; i++){
			ths+=this.m[i];
			tht+=that.m[i];
		}

		return ths.equals(tht);
	}
	public String toString(){
		String output = "";
		for(int i=0; i<9; i++){
			output+=m[i];
			output+=" ";
			if(i%3==2) output +='\n';
		}
		return output;
	}
	public String printMatrix(){
		String output = m[0]+" "+m[1]+" "+m[2]+"      "+m[0]+" "+m[1]+" "+m[2]+'\n'+
						m[3]+" "+m[4]+" "+m[5]+"      "+m[3]+" "+m[4]+" "+m[9]+'\n'+
						m[6]+" "+m[7]+" "+m[8]+"      "+m[10]+" "+m[11]+" "+m[12]+'\n';
		return output;
	}
	public String rowRep(){//row representation
		return ""+m[0]+m[1]+m[2]+m[3]+m[4]+m[5]+m[6]+m[7]+m[8];
	}
	public String columnRep(){//row representation
		return ""+m[0]+m[3]+m[6]+m[1]+m[4]+m[7]+m[2]+m[5]+m[8];
	}	
}
